int box(int** A, int m, int n){
	int i, j, count = 0;
	for(i = 0; i < m - 2; ++i){
		for(j = 0; j < n - 2; ++j){
			if(  A[i][j]   &&  A[i][j+1]   &&  A[i][j+2]   &&
				 A[i+1][j] && !A[i+1][j+1] &&  A[i+1][j+2] &&
				 A[i+1][j] &&  A[i+1][j+1] &&  A[i+1][j+2]    ) ++count;
		}
	}
	return count;
}

int diamond(int** A, int m, int n){
	int i, j, count = 0;
	for(i = 0; i < m - 2; ++i){
		for(j = 0; j < n - 2; ++j){
			if( !A[i][j]   &&  A[i][j+1]   && !A[i][j+2]   &&
				 A[i+1][j] && !A[i+1][j+1] &&  A[i+1][j+2] &&
				!A[i+1][j] &&  A[i+1][j+1] && !A[i+1][j+2]    ) ++count;
		}
	}
	return count;
}

int cross(int** A, int m, int n){
	int i, j, count = 0;
	for(i = 0; i < m - 2; ++i){
		for(j = 0; j < n - 2; ++j){
			if(  A[i][j]   && !A[i][j+1]   &&  A[i][j+2]   &&
				!A[i+1][j] &&  A[i+1][j+1] && !A[i+1][j+2] &&
				 A[i+1][j] && !A[i+1][j+1] &&  A[i+1][j+2]    ) ++count;
		}
	}
	return count;
}

int plus(int** A, int m, int n){
	int i, j, count = 0;
	for(i = 0; i < m - 2; ++i){
		for(j = 0; j < n - 2; ++j){
			if( !A[i][j]   &&  A[i][j+1]   && !A[i][j+2]   &&
				 A[i+1][j] &&  A[i+1][j+1] &&  A[i+1][j+2] &&
				!A[i+1][j] &&  A[i+1][j+1] && !A[i+1][j+2]    ) ++count;
		}
	}
	return count;
}